// FullAccess
resource "azurerm_role_definition" "azure_dns_fullaccess_definition" {
  name              = "azure-dns-fullaccess-definition"
  scope             = "/subscriptions/${var.subscription_id}"
  assignable_scopes = "/subscriptions/${var.subscription_id}"

  permissions {
    actions = [
      "Microsoft.DomainRegistration/generateSsoRequest/Action",
      "Microsoft.DomainRegistration/validateDomainRegistrationInformation/Action",
      "Microsoft.DomainRegistration/checkDomainAvailability/Action",
      "Microsoft.DomainRegistration/listDomainRecommendations/Action",
      "Microsoft.DomainRegistration/register/action",
      "Microsoft.DomainRegistration/domains/Read",
      "Microsoft.DomainRegistration/domains/Read",
      "Microsoft.DomainRegistration/domains/Write",
      "Microsoft.DomainRegistration/domains/Delete",
      "Microsoft.DomainRegistration/domains/renew/Action",
      "Microsoft.DomainRegistration/domains/operationresults/Read",
      "Microsoft.DomainRegistration/domains/domainownershipidentifiers/Read",
      "Microsoft.DomainRegistration/domains/domainownershipidentifiers/Read",
      "Microsoft.DomainRegistration/domains/domainownershipidentifiers/Write",
      "Microsoft.DomainRegistration/domains/domainownershipidentifiers/Delete",
      "Microsoft.DomainRegistration/topLevelDomains/Read",
      "Microsoft.DomainRegistration/topLevelDomains/Read",
      "Microsoft.DomainRegistration/topLevelDomains/listAgreements/Action",
      "Microsoft.DomainRegistration/operations/Read",
      "Microsoft.Network/dnszones/read",
      "Microsoft.Network/dnszones/write",
      "Microsoft.Network/dnszones/delete",
      "Microsoft.Network/dnsoperationresults/read",
      "Microsoft.Network/dnsoperationstatuses/read",
      "Microsoft.Network/dnszones/all/read",
      "Microsoft.Network/dnszones/recordsets/read",
      "Microsoft.Network/dnszones/A/read",
      "Microsoft.Network/dnszones/A/write",
      "Microsoft.Network/dnszones/A/delete",
      "Microsoft.Network/dnszones/AAAA/read",
      "Microsoft.Network/dnszones/AAAA/write",
      "Microsoft.Network/dnszones/AAAA/delete",
      "Microsoft.Network/dnszones/PTR/read",
      "Microsoft.Network/dnszones/PTR/write",
      "Microsoft.Network/dnszones/PTR/delete",
      "Microsoft.Network/dnszones/MX/read",
      "Microsoft.Network/dnszones/MX/write",
      "Microsoft.Network/dnszones/MX/delete",
      "Microsoft.Network/dnszones/TXT/read",
      "Microsoft.Network/dnszones/TXT/write",
      "Microsoft.Network/dnszones/TXT/delete",
      "Microsoft.Network/dnszones/SRV/read",
      "Microsoft.Network/dnszones/SRV/write",
      "Microsoft.Network/dnszones/SRV/delete",
      "Microsoft.Network/dnszones/CNAME/read",
      "Microsoft.Network/dnszones/CNAME/write",
      "Microsoft.Network/dnszones/CNAME/delete",
      "Microsoft.Network/dnszones/NS/read",
      "Microsoft.Network/dnszones/NS/write",
      "Microsoft.Network/dnszones/NS/delete",
      "Microsoft.Network/dnszones/SOA/read",
      "Microsoft.Network/dnszones/SOA/write",
      "Microsoft.Network/dnszones/CAA/read",
      "Microsoft.Network/dnszones/CAA/write",
      "Microsoft.Network/dnszones/CAA/delete",
      "Microsoft.Network/privateDnsZones/read",
      "Microsoft.Network/privateDnsZones/write",
      "Microsoft.Network/privateDnsZones/delete",
      "Microsoft.Network/privateDnsZones/virtualNetworkLinks/read",
      "Microsoft.Network/privateDnsZones/virtualNetworkLinks/write",
      "Microsoft.Network/privateDnsZones/virtualNetworkLinks/delete",
      "Microsoft.Network/privateDnsZones/A/read",
      "Microsoft.Network/privateDnsZones/A/write",
      "Microsoft.Network/privateDnsZones/A/delete",
      "Microsoft.Network/privateDnsZones/AAAA/read",
      "Microsoft.Network/privateDnsZones/AAAA/write",
      "Microsoft.Network/privateDnsZones/AAAA/delete",
      "Microsoft.Network/privateDnsZones/CNAME/read",
      "Microsoft.Network/privateDnsZones/CNAME/write",
      "Microsoft.Network/privateDnsZones/CNAME/delete",
      "Microsoft.Network/privateDnsZones/MX/read",
      "Microsoft.Network/privateDnsZones/MX/write",
      "Microsoft.Network/privateDnsZones/MX/delete",
      "Microsoft.Network/privateDnsZones/PTR/read",
      "Microsoft.Network/privateDnsZones/PTR/write",
      "Microsoft.Network/privateDnsZones/PTR/delete",
      "Microsoft.Network/privateDnsZones/SOA/read",
      "Microsoft.Network/privateDnsZones/SOA/write",
      "Microsoft.Network/privateDnsZones/SRV/read",
      "Microsoft.Network/privateDnsZones/SRV/write",
      "Microsoft.Network/privateDnsZones/SRV/delete",
      "Microsoft.Network/privateDnsZones/TXT/read",
      "Microsoft.Network/privateDnsZones/TXT/write",
      "Microsoft.Network/privateDnsZones/TXT/delete",
      "Microsoft.Network/privateDnsZones/ALL/read",
      "Microsoft.Network/privateDnsZones/recordsets/read",
      "Microsoft.Network/privateDnsOperationResults/read",
      "Microsoft.Network/privateDnsOperationStatuses/read",
    ]

    not_actions = []
  }
}

// ReadOnly
resource "azurerm_role_definition" "azure_dns_readonly_definition" {
  name              = "azure-dns-readonly-definition"
  scope             = "/subscriptions/${var.subscription_id}"
  assignable_scopes = "/subscriptions/${var.subscription_id}"

  permissions {
    actions = [
      "Microsoft.DomainRegistration/domains/Read",
      "Microsoft.DomainRegistration/domains/Read",
      "Microsoft.DomainRegistration/domains/operationresults/Read",
      "Microsoft.DomainRegistration/domains/domainownershipidentifiers/Read",
      "Microsoft.DomainRegistration/domains/domainownershipidentifiers/Read",
      "Microsoft.DomainRegistration/topLevelDomains/Read",
      "Microsoft.DomainRegistration/topLevelDomains/Read",
      "Microsoft.DomainRegistration/operations/Read",
      "Microsoft.Network/dnszones/read",
      "Microsoft.Network/dnsoperationresults/read",
      "Microsoft.Network/dnsoperationstatuses/read",
      "Microsoft.Network/dnszones/all/read",
      "Microsoft.Network/dnszones/recordsets/read",
      "Microsoft.Network/dnszones/A/read",
      "Microsoft.Network/dnszones/AAAA/read",
      "Microsoft.Network/dnszones/PTR/read",
      "Microsoft.Network/dnszones/MX/read",
      "Microsoft.Network/dnszones/TXT/read",
      "Microsoft.Network/dnszones/SRV/read",
      "Microsoft.Network/dnszones/CNAME/read",
      "Microsoft.Network/dnszones/NS/read",
      "Microsoft.Network/dnszones/SOA/read",
      "Microsoft.Network/dnszones/CAA/read",
      "Microsoft.Network/privateDnsZones/read",
      "Microsoft.Network/privateDnsZones/virtualNetworkLinks/read",
      "Microsoft.Network/privateDnsZones/A/read",
      "Microsoft.Network/privateDnsZones/AAAA/read",
      "Microsoft.Network/privateDnsZones/CNAME/read",
      "Microsoft.Network/privateDnsZones/MX/read",
      "Microsoft.Network/privateDnsZones/PTR/read",
      "Microsoft.Network/privateDnsZones/SOA/read",
      "Microsoft.Network/privateDnsZones/SRV/read",
      "Microsoft.Network/privateDnsZones/TXT/read",
      "Microsoft.Network/privateDnsZones/ALL/read",
      "Microsoft.Network/privateDnsZones/recordsets/read",
      "Microsoft.Network/privateDnsOperationResults/read",
      "Microsoft.Network/privateDnsOperationStatuses/read",
    ]

    not_actions = [
      "Microsoft.DomainRegistration/generateSsoRequest/Action",
      "Microsoft.DomainRegistration/validateDomainRegistrationInformation/Action",
      "Microsoft.DomainRegistration/checkDomainAvailability/Action",
      "Microsoft.DomainRegistration/listDomainRecommendations/Action",
      "Microsoft.DomainRegistration/register/action",
      "Microsoft.DomainRegistration/domains/Write",
      "Microsoft.DomainRegistration/domains/Delete",
      "Microsoft.DomainRegistration/domains/renew/Action",
      "Microsoft.DomainRegistration/domains/domainownershipidentifiers/Write",
      "Microsoft.DomainRegistration/domains/domainownershipidentifiers/Delete",
      "Microsoft.DomainRegistration/topLevelDomains/listAgreements/Action",
      "Microsoft.Network/dnszones/write",
      "Microsoft.Network/dnszones/delete",
      "Microsoft.Network/dnszones/A/write",
      "Microsoft.Network/dnszones/A/delete",
      "Microsoft.Network/dnszones/AAAA/write",
      "Microsoft.Network/dnszones/AAAA/delete",
      "Microsoft.Network/dnszones/PTR/write",
      "Microsoft.Network/dnszones/PTR/delete",
      "Microsoft.Network/dnszones/MX/write",
      "Microsoft.Network/dnszones/MX/delete",
      "Microsoft.Network/dnszones/TXT/write",
      "Microsoft.Network/dnszones/TXT/delete",
      "Microsoft.Network/dnszones/SRV/write",
      "Microsoft.Network/dnszones/SRV/delete",
      "Microsoft.Network/dnszones/CNAME/write",
      "Microsoft.Network/dnszones/CNAME/delete",
      "Microsoft.Network/dnszones/NS/write",
      "Microsoft.Network/dnszones/NS/delete",
      "Microsoft.Network/dnszones/SOA/write",
      "Microsoft.Network/dnszones/CAA/write",
      "Microsoft.Network/dnszones/CAA/delete",
      "Microsoft.Network/privateDnsZones/write",
      "Microsoft.Network/privateDnsZones/delete",
      "Microsoft.Network/privateDnsZones/virtualNetworkLinks/write",
      "Microsoft.Network/privateDnsZones/virtualNetworkLinks/delete",
      "Microsoft.Network/privateDnsZones/A/write",
      "Microsoft.Network/privateDnsZones/A/delete",
      "Microsoft.Network/privateDnsZones/AAAA/write",
      "Microsoft.Network/privateDnsZones/AAAA/delete",
      "Microsoft.Network/privateDnsZones/CNAME/write",
      "Microsoft.Network/privateDnsZones/CNAME/delete",
      "Microsoft.Network/privateDnsZones/MX/write",
      "Microsoft.Network/privateDnsZones/MX/delete",
      "Microsoft.Network/privateDnsZones/PTR/write",
      "Microsoft.Network/privateDnsZones/PTR/delete",
      "Microsoft.Network/privateDnsZones/SOA/write",
      "Microsoft.Network/privateDnsZones/SRV/write",
      "Microsoft.Network/privateDnsZones/SRV/delete",
      "Microsoft.Network/privateDnsZones/TXT/write",
      "Microsoft.Network/privateDnsZones/TXT/delete",
    ]
  }
}

// NoAccess
resource "azurerm_role_definition" "azure_dns_noaccess_definition" {
  name              = "azure-dns-noaccess-definition"
  scope             = "/subscriptions/${var.subscription_id}"
  assignable_scopes = "/subscriptions/${var.subscription_id}"

  permissions {
    actions = []

    not_actions = [
      "Microsoft.DomainRegistration/generateSsoRequest/Action",
      "Microsoft.DomainRegistration/validateDomainRegistrationInformation/Action",
      "Microsoft.DomainRegistration/checkDomainAvailability/Action",
      "Microsoft.DomainRegistration/listDomainRecommendations/Action",
      "Microsoft.DomainRegistration/register/action",
      "Microsoft.DomainRegistration/domains/Read",
      "Microsoft.DomainRegistration/domains/Read",
      "Microsoft.DomainRegistration/domains/Write",
      "Microsoft.DomainRegistration/domains/Delete",
      "Microsoft.DomainRegistration/domains/renew/Action",
      "Microsoft.DomainRegistration/domains/operationresults/Read",
      "Microsoft.DomainRegistration/domains/domainownershipidentifiers/Read",
      "Microsoft.DomainRegistration/domains/domainownershipidentifiers/Read",
      "Microsoft.DomainRegistration/domains/domainownershipidentifiers/Write",
      "Microsoft.DomainRegistration/domains/domainownershipidentifiers/Delete",
      "Microsoft.DomainRegistration/topLevelDomains/Read",
      "Microsoft.DomainRegistration/topLevelDomains/Read",
      "Microsoft.DomainRegistration/topLevelDomains/listAgreements/Action",
      "Microsoft.DomainRegistration/operations/Read",
      "Microsoft.Network/dnszones/read",
      "Microsoft.Network/dnszones/write",
      "Microsoft.Network/dnszones/delete",
      "Microsoft.Network/dnsoperationresults/read",
      "Microsoft.Network/dnsoperationstatuses/read",
      "Microsoft.Network/dnszones/all/read",
      "Microsoft.Network/dnszones/recordsets/read",
      "Microsoft.Network/dnszones/A/read",
      "Microsoft.Network/dnszones/A/write",
      "Microsoft.Network/dnszones/A/delete",
      "Microsoft.Network/dnszones/AAAA/read",
      "Microsoft.Network/dnszones/AAAA/write",
      "Microsoft.Network/dnszones/AAAA/delete",
      "Microsoft.Network/dnszones/PTR/read",
      "Microsoft.Network/dnszones/PTR/write",
      "Microsoft.Network/dnszones/PTR/delete",
      "Microsoft.Network/dnszones/MX/read",
      "Microsoft.Network/dnszones/MX/write",
      "Microsoft.Network/dnszones/MX/delete",
      "Microsoft.Network/dnszones/TXT/read",
      "Microsoft.Network/dnszones/TXT/write",
      "Microsoft.Network/dnszones/TXT/delete",
      "Microsoft.Network/dnszones/SRV/read",
      "Microsoft.Network/dnszones/SRV/write",
      "Microsoft.Network/dnszones/SRV/delete",
      "Microsoft.Network/dnszones/CNAME/read",
      "Microsoft.Network/dnszones/CNAME/write",
      "Microsoft.Network/dnszones/CNAME/delete",
      "Microsoft.Network/dnszones/NS/read",
      "Microsoft.Network/dnszones/NS/write",
      "Microsoft.Network/dnszones/NS/delete",
      "Microsoft.Network/dnszones/SOA/read",
      "Microsoft.Network/dnszones/SOA/write",
      "Microsoft.Network/dnszones/CAA/read",
      "Microsoft.Network/dnszones/CAA/write",
      "Microsoft.Network/dnszones/CAA/delete",
      "Microsoft.Network/privateDnsZones/read",
      "Microsoft.Network/privateDnsZones/write",
      "Microsoft.Network/privateDnsZones/delete",
      "Microsoft.Network/privateDnsZones/virtualNetworkLinks/read",
      "Microsoft.Network/privateDnsZones/virtualNetworkLinks/write",
      "Microsoft.Network/privateDnsZones/virtualNetworkLinks/delete",
      "Microsoft.Network/privateDnsZones/A/read",
      "Microsoft.Network/privateDnsZones/A/write",
      "Microsoft.Network/privateDnsZones/A/delete",
      "Microsoft.Network/privateDnsZones/AAAA/read",
      "Microsoft.Network/privateDnsZones/AAAA/write",
      "Microsoft.Network/privateDnsZones/AAAA/delete",
      "Microsoft.Network/privateDnsZones/CNAME/read",
      "Microsoft.Network/privateDnsZones/CNAME/write",
      "Microsoft.Network/privateDnsZones/CNAME/delete",
      "Microsoft.Network/privateDnsZones/MX/read",
      "Microsoft.Network/privateDnsZones/MX/write",
      "Microsoft.Network/privateDnsZones/MX/delete",
      "Microsoft.Network/privateDnsZones/PTR/read",
      "Microsoft.Network/privateDnsZones/PTR/write",
      "Microsoft.Network/privateDnsZones/PTR/delete",
      "Microsoft.Network/privateDnsZones/SOA/read",
      "Microsoft.Network/privateDnsZones/SOA/write",
      "Microsoft.Network/privateDnsZones/SRV/read",
      "Microsoft.Network/privateDnsZones/SRV/write",
      "Microsoft.Network/privateDnsZones/SRV/delete",
      "Microsoft.Network/privateDnsZones/TXT/read",
      "Microsoft.Network/privateDnsZones/TXT/write",
      "Microsoft.Network/privateDnsZones/TXT/delete",
      "Microsoft.Network/privateDnsZones/ALL/read",
      "Microsoft.Network/privateDnsZones/recordsets/read",
      "Microsoft.Network/privateDnsOperationResults/read",
      "Microsoft.Network/privateDnsOperationStatuses/read",
    ]
  }
}
